
.include 	"m8515def.inc"

.include	"Definitionen.inc"

;****************************** Verktor-Liste ****************************

.CSEG
                rjmp    Reset
.org OC0addr
				rjmp	irq_timer

;****************************** Programm-Beginn **********************

;*********************************************************************
;  Initialisierungsroutine
;*********************************************************************

.ORG	INT_VECTORS_SIZE

; Hardware initialisieren

Reset:  ldi     TEMP_0,low(RAMEND)          ; Stack an das interne Ram-Ende
        out     SPL,TEMP_0
        ldi     TEMP_0,high(RAMEND)
        out     SPH,TEMP_0

; Externer Ram ein ***************************************************

;		ldi		TEMP_0,(1<<SRW11)
;		out		EMCUCR,TEMP_0
		ldi		TEMP_0,(1<<SRE); ext. Ram ein, 64k, alle Leitungen | (1<<SRW10)
		out		MCUCR,TEMP_0

; Port A *************************************************************

        ser     TEMP_0						; Alle PullUp ein bzw. Ausgang auf High
        out     PORTA,TEMP_0
        out     DDRA,TEMP_0

; Port B *************************************************************

        ser		TEMP_0						; Alle PullUp ein bzw. Ausgang auf High
		out     PORTB,TEMP_0
        out     DDRB,TEMP_0	

; Port C *************************************************************

        ser     TEMP_0						; Alle PullUp ein bzw. Ausgang auf High
        out     PORTC,TEMP_0
        out     DDRC,TEMP_0	

; Port D *************************************************************

		ser		TEMP_0						; Alle PullUp ein bzw. Ausgang auf High
        out     PORTD,TEMP_0
		out     DDRD,TEMP_0

; Port E *************************************************************

		ser		TEMP_0						; Alle PullUp ein bzw. Ausgang auf High
        out     PORTE,TEMP_0
        out     DDRE,TEMP_0

; TIMER 8Bit *********************************************************

		ldi		TEMP_0,TCONST_TIME
		out		OCR0,TEMP_0

		ldi		TEMP_0,(1<<WGM01)|(1<<CS00)	; CTC, Vorteiler = 1
		out		TCCR0,TEMP_0

		ldi 	TEMP_0,(1<<OCIE0)			; Compare2 Interrupt: Beginn der Datenausgabe
		out 	TIMSK, TEMP_0

; UART ***************************************************************

        ldi     TEMP_0,high(UART_BAUD_SELECT)
        out     UBRRH,TEMP_0
        ldi     TEMP_0,low(UART_BAUD_SELECT)
        out     UBRRL,TEMP_0
        ldi     TEMP_0,(1<<TXEN)
        out     UCSRB,TEMP_0
        ldi     TEMP_0,(1<<URSEL)+(1<<UCSZ1)+(1<<UCSZ0)
        out     UCSRC,TEMP_0

; SPI ****************************************************************

        ldi     TEMP_0,(1<<SPI2X)				; SPI Clock *2
        out     SPSR,TEMP_0
        ldi     TEMP_0,(1<<MSTR) | (1<<SPE) | (1<<SPR0)	; Enable SPI-Master, Clock 2MHz
        out     SPCR,TEMP_0	    	        	; SPI initialisieren
        in      TEMP_0,SPSR   	            	; Flags lschen

;*********************************************************************				 

; Software initialisieren

		load_p	X,DDRAM+(X_SIZE*Y_SIZE)			; X auf DisplayEnde fr Refresh
		clr		YL								; Cursor auf Display-Anfang
		clr		YH
		ldi		X_REG,X_SIZE+1					; 61. Zyklus ist Latch/Zeilenwechsel
		ldi		Y_REG,Y_SIZE
		ldi		TEMP_0,M_MASK
		mov		M_MASK_REG,TEMP_0

		sei

		rcall	clear_display
										 
;*********************************************************************
;  Main-Loop
;*********************************************************************

main:
/*
		push	YL
		push	YH

		ldi		TEMP_0,BANK_2
		out		BANK_PORT,TEMP_0				; Flash auf Bank 0

		load_p	Y,DDRAM
		load_p	Z,FLASH
		ldi		TEMP_2,low(LINE_LEN*Y_SIZE)
		ldi		TEMP_3,high(LINE_LEN*Y_SIZE)

loop:
		ld		TEMP_0,Z+
		st		Y+,TEMP_0
		dec		TEMP_2
		brne	loop

		dec		TEMP_3
		brne	loop


		pop		YH
		pop		YL

*/
		ldi		TEMP_0,' '+1

		ldi		TEMP_1,30						; Zeichen pro Zeile

main_loop_1:
		push	TEMP_0
		push	TEMP_1
		rcall	write_char
		pop		TEMP_1
		pop		TEMP_0

		rcall	send_byte

		dec		TEMP_1
		brne	main_loop_2

		subi	YL,-(low(900+256))				; Anfang nchste Zeile,
		sbci	YH,-(high(900+256))

		ldi		TEMP_1,30

main_loop_2:
		inc		TEMP_0
		cpi		TEMP_0,0x80
		brne	main_loop_1


main_end:
		rjmp	main_end

;*********************************************************************
;  Ende Main-Loop
;*********************************************************************


;***************************************************************************
;  Programm Ende 
;***************************************************************************

.include	"subroutinen.inc"
.include	"irq.inc"
.include	"uart.inc"
.include	"12x16_horizontal_LSB_1.asm"

