
;************** IRQ - Routinen ********************************************				 

;*********************************************************************
;  Timer 0 Interrupt, 200kHz, 80 Takte bei 16MHz
;	19 Zyklen pro Byte in der Zeile
;	23 Zyklen bei Zeilenwechsel
;	29 Zyklen bei Framewechsel
;  Scratch-Reg: -
;*********************************************************************

irq_timer:
		in		REGSAVE,SREG			; #1 SREG retten
		dec		X_REG					; #1 Zeilenende?
		breq	irq_timer_line_end		; #1/#2 ja

		sbiw	X,1						; #2/--
		ld		TEMP_IRQ,X				; #2/-- nein, Daten aus Ram holen
		out		SPDR,TEMP_IRQ			; #1/--mit SPI rausschieben
		rjmp	irq_timer_end			; #2/--

irq_timer_line_end:
		sbi		LCD_PORT,LCD_LP			; --/#2 Zeile ins Latch
		ldi		X_REG,X_SIZE+1			; --/#1 61. Zyklus ist Latch/Zeilenwechsel
		cbi		LCD_PORT,LCD_LP			; --/#2

		cbi		LCD_PORT,LCD_FLM		; --/#2 FLM auf L
			
irq_timer_line_0:
		dec		Y_REG					; --/#1 nchste Zeile
		brne	irq_timer_end			; --/#2/#1 nein

		sbi		LCD_PORT,LCD_FLM		; --/--/#2 FLM fr erste Zeile setzen

		in		TEMP_IRQ,LCD_PORT		; --/--/#1 M invertieren
		eor		TEMP_IRQ,M_MASK_REG		; --/--/#1
		out		LCD_PORT,TEMP_IRQ

		ldi		Y_REG,Y_SIZE			; --/--/#1 neues Bild
		load_p	X,DDRAM+(X_SIZE*Y_SIZE)	; --/--/#2 Startadresse wieder laden

irq_timer_end:
		out 	SREG,REGSAVE			; #1

		reti							; #4

