
;**************************** Allgemeine Routinen **************************

;*********************************************************************
;  Write Char schreibt ein Zeichen an Cursor-Position
;  In:  TEMP_0 ASCII fr Ausgabe
;.
;  Scratch-Reg: Z, TEMP_0, TEMP_1, TEMP_2, TEMP_3
;*********************************************************************

write_char:
		push	YL				; Cursor-Position retten
		push	YH
		
		ldi		TEMP_1,low(DDRAM)
		add		YL,TEMP_1		; Startadresse dazu
		ldi		TEMP_1,high(DDRAM)
		adc		YH,TEMP_1	

		load_p	Z,(2*font)		; Tabellenanfang
		subi	TEMP_0,0x20
		ldi		TEMP_1,32		; Zeichengre Anzahl Bytes Breite * Hhe
		mul		TEMP_0,TEMP_1	; ASCII * Breite
		add		ZL,MUL_LOW		; Zum Tabellenanfang dazu
		adc		ZH,MUL_HIGH		

		ldi		TEMP_1,FONT_HEIGHT	; Zeilen-Zhler

write_char_loop:
		lpm		TEMP_2,Z+		; rechtes Byte
		lpm		TEMP_3,Z+		; linkes Byte
		st		Y+,TEMP_3		; linkes Byte ins Displayram
		st		Y,TEMP_2		; rechtes Byte ins Displayram
		adiw	Y,X_SIZE-1		; Zeilenlnge dazu
		dec		TEMP_1
		brne	write_char_loop

write_char_end:		
		pop		YH
		pop		YL
		adiw	Y,2				; Zeichensatzbreite dazu

		ret

;*********************************************************************
;  Clear Display
;  
;.
;  Scratch-Reg: Z, TEMP_0
;*********************************************************************

clear_display:
		load_p	Y,DDRAM				; Startadresse

		load_p	Z, (60*64)+2 ;X_SIZE*(Y_SIZE+1)	; Displaygre in Byte

		clr		TEMP_0

clear_display_loop:
		st		Y+,TEMP_0
		sbiw	Z,1
		brne	clear_display_loop

		clr		YL					; Cursor auf Anfang
		clr		YH

		ret

